// 需要用到哪些东西的时候,就定义一个它的 @Configuration 再加一个 @Bean 注解,返回它的实例即可
// 在需要使用的类里面加上一个 @Autowired 注入即可
// 向后端(匹配系统)发请求的工具,想取得什么,就加一个 Bean 注解
package com.kob.backend.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.client.RestTemplate;

// 加注解 Configuration
// RestTemplate 用于处理 Spring 服务之间的 http 请求
@Configuration
public class RestTemplateConfig {
    @Bean
    public RestTemplate getRestTemplate(){
        return new RestTemplate();
    }
}
